# -*- coding: utf-8 -*-

'''
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''


import re,sys,urllib2,urlparse,HTMLParser


def request(url, post=None, headers=None, timeout='30'):
    try:
        handlers = []

        try:
            if sys.version_info < (2, 7, 9): raise Exception()
            import ssl; ssl_context = ssl.create_default_context()
            ssl_context.check_hostname = False
            ssl_context.verify_mode = ssl.CERT_NONE
            handlers += [urllib2.HTTPSHandler(context=ssl_context)]
            opener = urllib2.build_opener(*handlers)
            opener = urllib2.install_opener(opener)
        except:
            pass

        try: headers.update(headers)
        except: headers = {}
        if 'User-Agent' in headers:
            pass
        else:
            headers['User-Agent'] = 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko'

        headers['Referer'] = '%s://%s/' % (urlparse.urlparse(url).scheme, urlparse.urlparse(url).netloc)
        headers['Accept-Language'] = 'hu-HU,en-US'

        request = urllib2.Request(url, data=post, headers=headers)

        response = urllib2.urlopen(request, timeout=int(timeout))

        result = response.read(5242880)

        response.close()

        return result
    except:
        return


def parseDOM(html, name=u""):
    # Copyright (C) 2010-2011 Tobias Ussing And Henrik Mosgaard Jensen

    if isinstance(html, str):
        try:
            html = [html.decode("utf-8")]
        except:
            try:
                html = [html.decode("utf-8", "replace")]
            except:
                html = [html]

    elif isinstance(html, unicode):
        html = [html]
    elif not isinstance(html, list):
        return u""

    for item in html:
        lst = re.compile('(<' + name + '>)', re.M | re.S).findall(item)

        lst2 = []
        for match in lst:
            endstr = u"</" + name

            start = item.find(match)
            end = item.find(endstr, start)
            pos = item.find("<" + name, start + 1 )

            while pos < end and pos != -1:
                tend = item.find(endstr, end + len(endstr))
                if tend != -1:
                    end = tend
                pos = item.find("<" + name, pos + 1)

            if start == -1 and end == -1:
                temp = u""
            elif start > -1 and end > -1:
                temp = item[start + len(match):end]
            elif end > -1:
                temp = item[:end]
            elif start > -1:
                temp = item[start + len(match):]

            item = item[item.find(temp, item.find(match)) + len(temp):]
            lst2.append(temp)

    return lst2


def replaceHTMLCodes(txt):
    txt = re.sub("(&#[0-9]+)([^;^0-9]+)", "\\1;\\2", txt)
    txt = HTMLParser.HTMLParser().unescape(txt)
    txt = txt.replace("&quot;", "\"")
    txt = txt.replace("&amp;", "&")
    return txt
